//************************************************************
//             ASCII decimal to binary conversion
//************************************************************
// Reference: Numerical Solutions
//            Chapter 1
// File name: ASCDTODE
//
// Description:
//            A string of decimal digits is stored in
//            an array of type char. The digit string
//            is converted to binary and stored in a
//            variable of type unsigned long

#include <iostream.h>
#include <math.h>

// Prototypes
unsigned long AscDec2Bin(char[]);

main()
{
   unsigned long result;
   char decDigits[] = {"123,456,789"};
   int size;


   // Display binary
   cout << "\n\n\n";
   cout << "Decimal digits: " << decDigits;

   // Call conversion function
   result = AscDec2Bin(decDigits);

   // Display result
   cout << "\nBinary value: " << result ;

  return 0;

}


unsigned long AscDec2Bin( char digits[])
// Function to convert string of decimal digits to a binary
// value
// Pre:
//    digits[] is a char array of decimal digits.
//    The array can contain commas as separators.
// Post:
//    Returns the binary value of the digits
//    in a variable of type unsigned long
//
{

     int size = 0;                  // Array size
     unsigned long decWeight = 1;   // Decimal digit weight
     unsigned long accumulator = 0; // Temp value
     unsigned int bitOffset;        // Offset in bit array
     unsigned int digitPos = 0;     // Relative digit position
     char thisDigit;                // Storage for digit

     // Calculate array size
     while(digits[size])
	size++;

     // Routine starts at the least significant digit, which
     // has a weight of 1. The weight of other digits to the
     // left of the first one is 10 * the weight of the
     // previous one
     for(int counter = 0; counter < size; counter++)
     {
	bitOffset = (size - 1) - digitPos;

	if(digits[bitOffset] == ',')
	{
	   digitPos++;
	   continue;
	}
	// ASSERT:
	//       Valid decimal digit in the range 0 to 9
	// Convert ASCII ditit to binary
	thisDigit = digits[bitOffset] - 0x30;
	// Accumulate digit weight
	accumulator = accumulator + (thisDigit * decWeight);
	// Update digit weight
	decWeight *= 10;
	// Update digit position in string
	digitPos++;
     }
     return accumulator;

}


