//************************************************************
//           ASCII hexadecimal to binary conversion
//************************************************************
// Reference: Numerical Solutions
//            Chapter 1
// File name: ASCHTOBI
//
// Description:
//            A string of hexadecimal digits is stored in
//            an array of type char. The digit string
//            is converted to binary and stored in a
//            variable of type unsigned long
//

#include <iostream.h>
#include <math.h>

// Prototypes
unsigned long AscHex2Bin2(char[]);

main()
{
   unsigned long result;
   char hexDigits[] = {"0xff00aa77"};
   int size;


   // Display digits string
   cout << "\n\n\nHex digits: " << hexDigits;

   // Call conversion function
   result = AscHex2Bin2(hexDigits);

   // Display result
   cout << "\nBinary value: " << result ;

  return 0;

}

unsigned long AscHex2Bin2( char digits[])
// Function to convert string of hex digits to a binary
// value
// Pre:
//    digits[] is a char array of hex digits.
// Post:
//    Returns the binary value of the digits
//    in a variable of type unsigned long
// Note:
//    The function allows the standard C/C++ hex
//    format characters (0x) in the digit string.
//    Hex alpha characters (A through F) can be
//    upper- or lower-case.
//
{
     int size = 0;                  // Array size
     unsigned long hexWeight = 1;   // Digit weight
     unsigned long accumulator = 0; // Temp value
     unsigned int offset = 0;       // Offset in array
     unsigned int digitPos = 0;     // Relative digit position
     unsigned int digitValue;       // Binary digit value

     // Obtain the size of the array
     while(digits[size])
	 size++;

     // Routine starts at the least significant digit, which
     // has a weight of 1. The weight of other digits to the
     // left of the first one is 16 * the weight of the
     // previous bit
     for(int counter = 0; counter < size; counter++)
     {
	offset = (size - 1) - digitPos;

	if(digits[offset] == 'x')
	{
	   digitPos++;
	   continue;
	}
	// ASSERT:
	//       Valid hex digit in the range 0 to F
	// Convert ASCII ditit to binary

	if(digits[offset] < 'A')
	   digitValue = digits[offset] - 0x30;
	else
	{
	   // Test for upper case hex digit
	   if(digits[offset] < 'G')
	      digitValue = digits[offset] - 0x37;
	   else
	      digitValue = digits[offset] - 0x57;
	}

	// Accumulate digit weight
	accumulator = accumulator + (digitValue * hexWeight);
	// Update digit weight
	hexWeight *= 16;
	// Update digit position in string
	digitPos++;
     }
     return accumulator;

}
