//************************************************************
//            binary to ASCII hexadecimal conversion
//************************************************************
// Reference: Numerical Solutions
//            Chapter 1
//
// File name: BINTOHEX.CPP
//
// Description:
//            Converts a binary decimal number stored in a
//            variable of type unsigned long, into an array of
//            of ASCII hexadecimal digits

#include <iostream.h>
#include <math.h>

// Prototypes
void Bin2AscHex(char[], unsigned long);


main()
{

   unsigned long binaryVal = 123456789; // Test number
   char ascDigits[] = {"         "};    // ASCII digit array
   unsigned int size;                   // Array size

   // Display binary
   cout << "\n\n\n";
   cout << "Binary value: " << binaryVal;

   // Call conversion function
   Bin2AscHex(ascDigits, binaryVal);

   // Display array of digits
   cout << "\nDigit array: " << ascDigits;
   cout << "\n\n";

   return 0;

}


void Bin2AscHex( char digits[], unsigned long value)
// Function to convert a binary value into a string
// of ASCII hexadecimal digits
// Pre:
//    1. digits[] is a char array for storing the ASCII
//       hex digits
//    2. value is the binary number stored in a variable
//       of type unsigned long
//    3. Array is of sufficient size for storing all
//       ASCII hex digits. If not, the returned result is
//       invalid.
// Post:
//    Returns a string of ASCII hexadecimal digits in the
//    argument array

{
   int size = 0;                 // Elements in array
   unsigned int hexDigit;
   unsigned int factor = 0x37;   // Change to 0x57 to obtain
				 // lower-case digits in the
				 // range a to f

   // Calculate array size
   while(digits[size])
      size++;

   while(value > 0 && size > 0)
   {

    hexDigit = value % 16;
    // Convert and store digits in the range 0 to 9
    if(hexDigit < 10)
      digits[size-1] = hexDigit + 0x30;   // Obtain and store
					   // low-order digit
    else
      digits[size-1] = hexDigit + factor;

    // Note:
    //      If size is the number of elements in the digits
    //      array, then the storage offset is (size - 1)



    value = value / 16;                   // New operand
    size --;                              // Update digit position
   }


    return;
}


