//************************************************************
//          Financial errors in calculations
//************************************************************
// Reference:   SOFTWARE SOLUTIONS
// Workspace  : Chapter10\Financial Errors
// Entry point: Financial Errors
// Other files: 
//
// Development: Visual C++ 6.0 Console Application
// Date:        February 2/2001
//
// Description:
//              Testing for errors in financial calculations
//************************************************************
#include "stdafx.h"
#include <iostream.h>
#include <conio.h>
#include <stdio.h>
#include <iomanip.h>
#include "bcd20math.h"

int main()
{
    // Variables for program
	int menuOption = 1;
	char ascLarge[] = "988888888888888888";
	char ascSmall[] = "0.444444444444444444";
	char bcd20Large[20];
	char bcd20Small[20];
    char bcdResult[20];
    char ascResult[52];

	double large = 988888888888888888;
	double small = 0.444444444444444444;
	double result = 1, two = 2.0;
	double aNum = 1.0/3;
	// double num1 = 5.21e+14;
	double num1 = 512000000000000;
	double val = 0.0;
	int it, i;

	// Set width and precesion for output functions
    cout.precision(20);       // Max     
    cout.width(20);           // Max

 while(menuOption)
  { 
    // Display menu
	cout << " TEST MENU\n"
		 << "  0 = END TEST\n"
	     << "  1 = inexact result error\n"
		 << "  2 = representation error\n"
		 << "  3 = cancellation error\n"
		 << "  4 = decimal/binary conversion error\n"
		 << " SELECT: ";
    cin >> menuOption;
	
	switch(menuOption)
	{
    case 1:
    // Convert strings to BCD20 format
	AsciiToBcd20(ascLarge, bcd20Large);
	AsciiToBcd20(ascSmall, bcd20Small);
    // Multiply in BCD arithmetic
	SignMulBcd20(bcd20Small, bcd20Large, bcdResult);
	// Convert result to ASCII string
	Bcd20ToAscStr(bcdResult, ascResult);
	printf("large number 988,888,888,888,888,888 = ");
	printf("%.16f", large);
	printf("\n"); 
	printf("small number 0.444444444444444444 = ");
	printf("%.16f", small);
	printf("\n"); 
    printf("math unit product =  ");
	printf("%.16f", large * small);
	printf("\n");
	printf("BCD product       = ");
	printf(ascResult);
	printf("\n\n");
	break;

    case 2:
    // Representation error
	printf("Representation error\n");
	printf("The value 1/3 is stored as: ");
	printf("%.17f", aNum);
	printf("\n");
	val = 0.0;
	it = 1;
    for(i = 0; i < 10;i++)
    {
		printf("Iteration: ");
		printf("%.i", it);
		printf(" sum: ");
		printf("%.17f", val);
		printf("\n");
		val = val + aNum;
		it++;
	} 
	printf("\n");	
    break;

    case 3:
    // Cancellation error
    printf("Testing cancellation error\n");
	num1 = num1 + 0.0075;
	printf("The sum 512000000000000 + 0.0075 is: ");
	printf("%.16f", num1);
	printf("\n\n");
    break;

    case 4:
    // Decimal/binary conversion error
    it = 1;          // Iteration counter
	val = 0.0;
 	printf("Testing decimal/binary conversion error\n");
	printf("Calculating 0.1 + 0.1 + 0.1 ... until sum = 1.0\n");
    while(val != 1.0)
	{
		printf("Iteration: ");
		printf("%.i", it);
		printf(" sum: ");
		printf("%.17f", val);
		printf("\n");
    	val = val + 0.10;
		it++;
		if(val > 1.1)
		{ 
           printf("  OOPS !!! sum is now greater than 1.0\n");
		   printf("  While loop crashed\n\n");
           break;
		}
    }

    break;


    }	
  }
 return 0;
}

