//************************************************************
//        Testing financial primitives
//************************************************************
// Reference:   NUMERICAL SOLUTIONS
// Workspace  : Chapter10\Test Mu32_8
// Entry point: Test Mu32_8
// Other files: Un32_8.asm
//              Un32_8.h
// Development: Visual C++ 6.0 Console Application
// Date:        January 29/2001
//
// Description:
//              Tests for procedures in Un32_8 module of
//              math32.lib
//************************************************************
#include "stdafx.h"
#include "Un32_8.h"
#include <iostream.h>
#include <conio.h>
#include <stdio.h>
#include <iomanip.h>

int main()
{
    // Variables for program
	int menuOption = 1;
	double term, principal, payments, interestRate;
	double perPayment, presValue, futValue, ul;
	int timeUnits;
	double cost, salvage, slDep, startV, finalV;
    double cPeriods, effYield, anPR, aoip, annuity;
	double interest;

	// Set width and precesion for output functions
    cout.precision(20);       // Max     
    cout.width(20);           // Max

  while(menuOption)
  { 
    // Display menu
	cout << "FUNCTION TEST MENU\n"
		 << "  0 = END TEST\n"
	     << "  1 = Payments()\n"
		 << "  2 = AnnuityPv()\n"
		 << "  3 = AnnuityFv()\n"
		 << "  4 = SlDepreciation()\n"
		 << "  5 = CompPeriods()\n"
         << "  6 = FutureValue()\n"
		 << "  7 = PresentValue()\n"
		 << "  8 = EffectiveYield()\n"
		 << "  9 = Apr()\n"
		 << " 10 = AoiPayment()\n"
		 << " 11 = AnnuityDue()\n"
		 << " 12 = SinkingFund()\n"
		 << " 13 = SimpleInterest()\n"
		 << " SELECT: ";
    cin >> menuOption;
	
	switch(menuOption)
	{
    case 1:
    // Payments()
    cout << "\nTesting Payments()";
	cout << "\nEnter principal of loan: ";
	cin >> principal;
	cout << "Enter interest rate: ";
	cin >> interestRate;
	cout << "Enter number of years: ";
	cin >> term;
	cout << "Enter payment periods per year: ";
	cin >> timeUnits;
    payments = Payments(term, interestRate, principal, timeUnits); 
	cout << "Payments = " << payments << "\n\n";
	break;

    case 2:
    // AnnuityPv()
    cout << "\nTesting AnnuityPv()";
	cout << "\nEnter periodic payment: ";
	cin >> perPayment;
	cout << "Enter interest rate: ";
	cin >> interestRate;
	cout << "Enter number of years: ";
	cin >> term;
	cout << "Enter payment periods per year: ";
	cin >> timeUnits;
    presValue = AnnuityPv(term, interestRate, perPayment, timeUnits); 
	cout << "Annuity present value = " << presValue << "\n\n";
	break;

    case 3:
    // AnnuityFv()
    cout << "\nTesting AnnuityFv()";
	cout << "\nEnter periodic payment: ";
	cin >> perPayment;
	cout << "Enter interest rate: ";
	cin >> interestRate;
	cout << "Enter number of years: ";
	cin >> term;
	cout << "Enter payment periods per year: ";
	cin >> timeUnits;
    futValue = AnnuityFv(term, interestRate, perPayment, timeUnits); 
	cout << "Annuity future Value = " << futValue << "\n\n";
	break;

    case 4:
    // SlDepreciation()
    cout << "\nTesting SlDepreciation()";
	cout << "\nEnter item cost: ";
	cin >> cost;
	cout << "Enter item salvage value: ";
	cin >> salvage;
	cout << "Enter useful life (years): ";
	cin >> ul;
	cout << "Enter depreciation periods per year: ";
	cin >> timeUnits;
    slDep = SlDepreciation(cost, salvage, ul, timeUnits); 
	cout << "Depreciation allowance = " << slDep << "\n\n";
	break;

    case 5:
    // CompPeriods()
    cout << "\nTesting CompPeriods()";
	cout << "\nEnter starting value: ";
	cin >> startV;
	cout << "Enter final value: ";
	cin >> finalV;
	cout << "Enter interest rate: ";
	cin >> interestRate;
	cout << "Enter compounding periods per year: ";
	cin >> timeUnits;
    cPeriods = CompPeriods(interestRate, finalV, startV, timeUnits); 
	cout << "Compounding periods required = " << cPeriods << "\n\n";
	break;

	
    case 6:
    // FutureValue()
    cout << "\nTesting FutureValue()";
	cout << "\nEnter present value: ";
	cin >> principal;
	cout << "Enter interest rate: ";
	cin >> interestRate;
	cout << "Enter number of years: ";
	cin >> term;
	cout << "Enter compounding periods per year: ";
	cin >> timeUnits;
    futValue = FutureValue(term, interestRate, principal, timeUnits); 
	cout << "Future Value = " << futValue << "\n\n";
	break;

    case 7:
    // PresentValue()
    cout << "\nTesting PresentValue()";
	cout << "\nEnter future value: ";
	cin >> principal;
	cout << "Enter interest rate: ";
	cin >> interestRate;
	cout << "Enter number of years: ";
	cin >> term;
	cout << "Enter compounding periods per year: ";
	cin >> timeUnits;
    presValue = PresentValue(term, interestRate, principal, timeUnits); 
	cout << "Present value = " << presValue << "\n\n";
	break;
    
    case 8:
    // EffectiveYield()
    cout << "\nTesting EffectiveYield()";
	cout << "\nEnter interest rate: ";
	cin >> interestRate;
	cout << "Enter compounding periods per year: ";
	cin >> timeUnits;
    effYield = EffectiveYield(interestRate, timeUnits); 
	cout << "Effecitve yield = " << effYield << "\n\n";
	break;

    case 9:
    // Apr()
    cout << "\nTesting AnPerRate()";
	cout << "\nEnter interest rate: ";
	cin >> interestRate;
	cout << "Enter compounding periods per year: ";
	cin >> timeUnits;
    anPR = Apr(interestRate, timeUnits); 
	cout << "Annual Percentage Rate = " << anPR << "\n\n";
	break;
	
    case 10:
    // AoiPayment()
    cout << "\nTesting AoiPayment()";
	cout << "\nEnter principal of loan: ";
	cin >> principal;
	cout << "Enter interest rate: ";
	cin >> interestRate;
	cout << "Enter number of years: ";
	cin >> term;
	cout << "Enter payment periods per year: ";
	cin >> timeUnits;
    aoip = AoiPayment(term, interestRate, principal, timeUnits); 
	cout << "Add-on intrest payment = " << aoip << "\n\n";
	break;

    case 11:
    // AnnuityDue()
    cout << "\nTesting AnnuityDue()";
	cout << "\nEnter periodic payment: ";
	cin >> perPayment;
	cout << "Enter interest rate: ";
	cin >> interestRate;
	cout << "Enter number of years: ";
	cin >> term;
	cout << "Enter payment periods per year: ";
	cin >> timeUnits;
    futValue = AnnuityDue(term, interestRate, perPayment, timeUnits); 
	cout << "Annuity Due = " << futValue << "\n\n";
	break;

    case 12:
    // SinkingFund()
    cout << "\nTesting SinkingFund()";
	cout << "\nEnter annuity future value: ";
	cin >> annuity;
	cout << "Enter interest rate: ";
	cin >> interestRate;
	cout << "Enter number of years: ";
	cin >> term;
	cout << "Enter payment periods per year: ";
	cin >> timeUnits;
    payments = SinkingFund(term, interestRate, annuity, timeUnits); 
	cout << "Periodic payment = " << payments << "\n\n";
	break;

	case 13:
    // SimpleInterest()
    cout << "\nTesting SimpleInterest()";
	cout << "\nEnter principal of loan: ";
	cin >> principal;
	cout << "Enter annual interest rate: ";
	cin >> interestRate;
	cout << "Enter number of years: ";
	cin >> term;
    interest = SimpleInterest(term, interestRate, principal); 
	cout << "Simple interest = " << interest << "\n\n";
	break;
    }	
  }
 return 0;
}

