//************************************************************
//     Testing probablity and statistical primitives
//************************************************************
// Reference:   SOFTWARE SOLUTIONS
// Workspace  : Chapter10\Test Un32_9
// Entry point: Test Mu32_8
// Other files: Un32_9.asm
//              Un32_9.h
// Development: Visual C++ 6.0 Console Application
// Date:        February 9/2001
//
// Description:
//              Tests for procedures in Un32_9 module of
//              math32.lib
//************************************************************
#include "stdafx.h"
#include "Un32_9.h"
#include <iostream.h>
#include <conio.h>
#include <stdio.h>
#include <iomanip.h>
#include <cmath>


int main()
{
    // Variables for program
	int menuOption = 1;
	int nInSet, rInSet, i; 
    int perm, comb;
	int code = 0;
    double prob;
	double mean, median, midrange, sum, mode;
	double wMean, wMedian, wMode;
	double range, variance, stdDev, xVal, yVal;
	double aVal, bVal, area, linearCC, yInter, slope;
	double constE;

    // Arrays
	int val1[] = {10, 20, 30, 40, 50, 60, 70};
	double num1[] = { 10.1, 20.2, 30.3, 40.4, 50.5, 60.6, 70.7};
    int val2[] = {7, 4, 5, 6, 3, 9, 5, 1};
	double num2[] = { 20.1, 30.3, 50.5, 70.7, 10.1, 40.4, 60.6};
	int val3[] = {1, 2, 3, 4, 5, 6, 7, 8, 9};
	int val4[] = {1, 2, 3, 4, 4, 5, 6, 7, 8};
	int tstX[] = {1, 1, 1, 1, 1};
	int tstY[] = {2, 2, 2, 2, 2};
	double num4[] = { 20.1, 20.1, 50.5, 70.7, 10.1, 40.4, 40.4};
	int val5[] = {5, 6, 2, 3, 2, 4, 3, 2, 4, 1, 3, 6, 6};
	int val6[] = {1, 2, 3, 4, 5, 6};
	double num3[7];
	int freq[] = {18, 3, 2, 23, 1, 3};
	int dat[] = {0, 1, 2, 3, 4, 5};
	int dat1[] =  {8, 9, 9, 9, 10};
	double yDat[4];
    int datX[] = {30,40,30,35,45,15,15,50,30,00,20,10,25,25,25,
		          30,40,35,20,15};
	int datY[] = {72,85,75,78,89,58,71,94,78,10,75,43,68,60,70,
		          68,82,75,65,62};


	while(menuOption)
  { 
    // Display menu
	cout << "FUNCTION TEST MENU\n"
		 << "  0 = END TEST\n"
		 << "  1 = Permutations()        2 = Combinations()\n"
         << "  3 = BinomialProb()        4 = Array Operations\n"
		 << "  5 = Mean/Median/Midrange  6 = Mode and weighted MCT\n"
		 << "  7 = Dispersion            8 = Norm Dist 4 pts\n"
		 << "  9 = Normal distribution  10 = Normal prob trap \n"
		 << " 11 = Normal probability   12 = Linear corr. coefficient\n"
		 << " 13 = Regression y-inter.  14 = Regression slope\n"
		 << " 15 = Load constant e\n"
		 << " SELECT: ";
    cin >> menuOption;
	
	switch(menuOption)
	{
    case 1:
    // Permutations()
    cout << "\nTesting Permutations()";
	cout << "\nEnter n: ";
	cin >> nInSet;
	cout << "Enter r: ";
	cin >> rInSet;
    perm = Permutations(nInSet, rInSet);
	cout << "Permutations = " << perm << "\n";
	break;

    case 2:
    // Combinations()
    cout << "\nTesting Combinations()";
	cout << "\nEnter n: ";
	cin >> nInSet;
	cout << "Enter r: ";
	cin >> rInSet;
    comb = Combinations(nInSet, rInSet);
	cout << "Combinations = " << comb << "\n";
	break;

    case 3:
    // BinomialProb()
    cout << "\nTesting BinomialProb()";
	cout << "\nEnter n: ";
	cin >> nInSet;
	cout << "Enter r: ";
	cin >> rInSet;
    prob = BinomialProb(nInSet, rInSet);
	cout << "Binomial Probability = " << prob << "\n";
	break;

	case 4:
	// Testing array operations
    cout << "Testing array operations\n";
	sum = SIGx( tstX, sizeof tstX / sizeof tstX[0]);
	cout << "SIGx() on array tstX[1,1,1,1,1] = " << sum
		 << "\n";

	sum = SIGxSq( tstY, sizeof tstX / sizeof tstX[0]);
	cout << "SIGxSq() on array tstY[2,2,2,2,2] = " << sum
		 << "\n";

	sum = SIGxToSq( tstY, sizeof tstX / sizeof tstX[0]);
	cout << "SIGxToSq() on array tstY[2,2,2,2,2] = " << sum
		 << "\n";

	sum = SIGxy( tstX, tstY, sizeof tstX / sizeof tstX[0]);
	cout << "SIGxy() on arrays tstX[1,1,1,1,1] and tstY[2,2,2,2,2] = ";
	cout << sum << "\n";

	sum = SIGxyByn( tstX, tstY, 3, sizeof tstX / sizeof tstX[0]);
	cout << "SIGxyByn() on arrays tstX[] and tstY[], n = 3 = ";
	cout << sum << "\n";
	
	sum = SIGxBySIGy( tstX, tstY, sizeof tstX / sizeof tstX[0]);
	cout << "SIGxBySIGy() on arrays tstX[] and tstY[] = ";
	cout << sum << "\n";
	
	sum = SIGxSkipCnt(num1, 0, 7, sizeof num1 / sizeof num1[0]);
	cout << "Sum of 6 doubles, skipping 1 = " << sum
		 << "\n";
    sum = SIGxSkipCnt(val1, 1, 6, sizeof val1 / sizeof val1[0]);
	cout << "Sum of 7 integers, skipping 0 = " << sum
		 << "\n";
	cout << "Values in val2[]: ";
	ArrayShow(val2, sizeof val2 / sizeof val2[0]);
	cout << "\n";
	cout << "Sorted val2[]   : ";
	Sort(val2, sizeof val2 / sizeof val2[0]);
    ArrayShow(val2, sizeof val2 / sizeof val2[0]);
	cout << "\n";
	cout << "Values in num2[]  : ";
    ArrayShow(num2, sizeof num2 / sizeof num2[0]);
	cout << "\n";
	cout << "Copy sorted num3[]: ";
	SortCopy(num2, num3, sizeof num2 / sizeof num2[0]);
    ArrayShow(num3, sizeof num3 / sizeof num3[0]);
	cout << "\n";
	break;
          
	case 5:
	// Testing mean, median, and midrange
	cout << "Testing Mean(), Median(), and Midrange()\n";
    
	mean = MeanOf(num1, 2, 4, sizeof num1 / sizeof num1[0]);
	cout << "Mean of 4 doubles, skipping 2 = " << mean
		 << "\n";
    
	mean = MeanOf(val1, 1, 5, sizeof val1 / sizeof val1[0]);
	cout << "Mean of 5 integers, skipping 1 = " << mean
		 << "\n";
    
	mean = Mean(val1, sizeof val1 / sizeof val1[0]);
	cout << "Mean of array val1 : " << mean << "\n";

	
    median = Median(val6, sizeof val6 / sizeof val6[0]);
	cout << "Median of array val6 : " << median << "\n";		
	
    median = Median(val2, sizeof val2 / sizeof val2[0]);
	cout << "Median of array val2 : " << median << "\n";		

    median = Median(num2, sizeof num2 / sizeof num2[0]);
	cout << "Median of array num2 : " << median << "\n";

    midrange = Midrange(val5, sizeof val5 / sizeof val5[0]);
	cout << "Midrange of array val5[] (6-1): ";
	cout << midrange << "\n";
    cout << "\n";
	break;

	case 6:
	// Testing mode and weighted MCT
    mode = Mode(val4, &code, sizeof val4 / sizeof val4[0]);
	cout << "Mode of array val4 : " << mode << "\n";
	cout << "Mode code is: " << code << "\n";     
	
    mode = Mode(num4, &code, sizeof num4 / sizeof num4[0]);
	cout << "Mode of array num4 : " << mode << "\n";
	cout << "Mode code is: " << code << "\n";     

    mode = Mode(val5, &code, sizeof val5 / sizeof val5[0]);
	cout << "Mode of array val5 : " << mode << "\n";
	cout << "Mode code is: " << code << "\n";  
	
    wMean = WeightedMean(dat, freq, sizeof dat / sizeof dat[0]);
	cout << "Weighted mean of dat[] and freq[] arrays: ";
	cout << wMean << "\n";

    wMedian = WeightedMedian(dat, freq, sizeof dat / sizeof dat[0]);
	cout << "Weighted median of dat[] and freq[] arrays: ";
	cout << wMedian << "\n";	

    wMode = WeightedMode(dat, freq, sizeof dat / sizeof dat[0]);
	cout << "Weighted mode of dat[] and freq[] arrays: ";
	cout << wMode << "\n";
    cout << "\n";
	break;

	case 7:
 	// Testing measures of dispersion
    cout << "Testing measures of dispersion\n";   
	range = Range(val3, sizeof val3 / sizeof val3[0]);
	cout << "Range of val3[] : ";
	cout << range << "\n";

	variance = VarianceS(dat1, sizeof dat1 / sizeof dat1[0]);
	cout << "Variance of sample set dat1[]: ";
	cout << variance << "\n";	

	variance = VarianceP(dat1, sizeof dat1 / sizeof dat1[0]);
	cout << "Variance of population dat1[]: ";
	cout << variance << "\n";

	stdDev = StdDevS(dat1, sizeof dat1 / sizeof dat1[0]);
	cout << "Standard deviation of sample set dat1[]: ";
	cout << stdDev << "\n";

	stdDev = StdDevP(dat1, sizeof dat1 / sizeof dat1[0]);
	cout << "Standard deviation of population dat1[]: ";
	cout << stdDev << "\n";
    cout << "\n";    
	break; 

	case 8:
 	// Testing NormalDist4pts()
    cout << "Testing NormalDist4pts()\n";
	cout << "Enter mean: ";
	cin >> mean;
	cout << "Enter standard deviation: ";
	cin >> stdDev;
    NormalDist4Pts(yDat, mean, stdDev);
	// Dislay Data
	for(i = 0; i < 4; i++)
	{
		printf("%.16f", yDat[i]);
	    printf("   ");
	}
	cout << "\n";
	break; 

	case 9:
 	// Testing NormalDistY()
    cout << "Testing NormalDistY()\n";
	cout << "Enter x : ";
	cin >> xVal;
	cout << "Enter mean: ";
	cin >> mean;
	cout << "Enter standard deviation: ";
	cin >> stdDev;
    yVal = NormalDistY(xVal, mean, stdDev);
	printf("y = ");
	printf("%.16f", yVal);
	printf("\n");
	break; 

	case 10:
 	// Testing NormalProbTrpz()
    cout << "Testing NormalProbTrpz()\n";
	cout << "Enter a (lower limit): ";
	cin >> aVal;
	cout << "Enter b (higher limit): ";
	cin >> bVal;
	cout << "Enter mean: ";
	cin >> mean;
	cout << "Enter standard deviation: ";
	cin >> stdDev;
    area = NormalProbTrpz(aVal, bVal, mean, stdDev);
	printf("Percent probability = ");
	printf("%.16f", area);
	printf("\n");
	break; 

	case 11:
 	// Testing NormalProbSimp
    cout << "Testing NormalProb()\n";
	cout << "Enter a (lower limit): ";
	cin >> aVal;
	cout << "Enter b (higher limit): ";
	cin >> bVal;
	cout << "Enter mean: ";
	cin >> mean;
	cout << "Enter standard deviation: ";
	cin >> stdDev;
    area = NormalProb(aVal, bVal, mean, stdDev);
	printf("Percent probability = ");
	printf("%.16f", area);
	printf("\n");
	break;

	case 12:
 	// Testing LinCorCoef()
    linearCC = LinCorCoef(datX, datY, sizeof datX / sizeof datX[0]);
	printf("Linear correlation coefficient for DatX[] and DatY[] = ");
	printf("%.16f", linearCC);
	printf("\n");
	break;

	case 13:
 	// Testing RegrYInt()
    yInter = RegrYInt(datX, datY, sizeof datX / sizeof datX[0]);
	printf("Linear regression y-intercept for DatX[] and DatY[] = ");
	printf("%.16f", yInter);
	printf("\n");
	break;

	case 14:
 	// Testing RegrSlope()
    slope = RegrSlope(datX, datY, sizeof datX / sizeof datX[0]);
	printf("Linear regression slope for DatX[] and DatY[] = ");
	printf("%.16f", slope);
	printf("\n");
	break;

	case 15:
 	// Testing LoadE()
    constE = LoadE();
	printf("Constant e = ");
	printf("%.16f", constE);
	printf("\n");
	break;

    }
	}
 return 0;
}



