//************************************************************
//     Testing interpolation, differentiation, and 
//               integration primitives
//************************************************************
// Reference:   SOFTWARE SOLUTIONS
// Workspace  : Chapter12\Test Un32_10
// Entry point: Test Un32_10
// Other files: 
//              Un32_10.h
// Development: Visual C++ 6.0 Console Application
// Date:        March 1/2001
//
// Description:
//              Tests for procedures in Un32_10 module of
//              math32.lib
//************************************************************
#include "Un32_10.h"
#include <iostream.h>
#include <conio.h>
#include <stdio.h>
#include <iomanip.h>
#include <cmath>
#include <math.h>


int main()
{

    // Variables for program
	int menuOption = 1;
    int j = 0;
    double res = 0;
	double aX[] = {0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0};   // x 
	double aY[] = {0.0, 2.0, 4.0, 6.0, 8.0, 10.0, 12.0}; // y = 2x
    double lX[] = {2.0, 3.0, 4.0, 5.0};
	double lY[] = {0.5, 0.333333333, 0.25, 0.2};
    int datX[] = {30,40,30,35,45,15,15,50,30,00,20,10,25,25,25,
		          30,40,35,20,15};
	int datY[] = {72,85,75,78,89,58,71,94,78,10,75,43,68,60,70,
		          68,82,75,65,62};
	int pxk = 10;
	double error;
      
    // Data for testing linear interpolation by least squares
	// m = 2, b = 1
    double valX[] = {1.0, 2.0, 3.0, 4.0, 5.0, 6.0};
	// double valY[] = {3.0, 5.0, 7.0, 9.0, 11.0, 13.0};
	double valY[] = {2.9, 5.1, 6.9, 9.1, 10.9, 13.1};
    double px = 3.5;
	// f(x) = 2x^2
	double fofX[] = {1.0, 2.0, 3.0, 4.0, 5.0, 6.0};
	double fofY[] = {4.0, 16.0, 36.0, 64.0, 100.0, 144.0};
	double fofx = 4.5;

	// Arrays for derivatives
	double srcY[] = {0.0, 0.3, 1.2, 2.7, 4.5, 6.3, 8.1};
	double drvS[7]; 
	double yVal;

    // Arrrays and data for integrals
	double integral;
	double xData[] = {0.0, 0.2,  0.4,  0.6,  0.8,  1.0};
	double yData[] = {4.0, 3.27, 2.68, 2.20, 1.80, 1.47};

	double xDat1[] = {1.0, 2.0, 3.0,  4.0,  5.0,  6.0, 7.0};
	double yDat1[] = {1.0, 4.0, 9.0, 16.0, 25.0, 36.0, 49.0};

	double xDat2[] = {1.0, 2.5,   3.5,   3.8,   5.0,  5.5,   5.8,   6.0};
	double yDat2[] = {1.0, 6.25, 12.25, 14.44, 25.0, 30.25, 33.64, 36.0};

	while(menuOption)
  { 
    // Display menu
	cout << "FUNCTION TEST MENU\n"
		 << "  0 = END TEST\n"
		 << "  1 = InterpLinPky\n"
		 << "  2 = InterpLinFromTable()\n"
		 << "  3 = InterpLagrange()\n"
		 << "  4 = LinearLSInterp()\n"
		 << "  5 = NonLinLSInterp()\n"
		 << "  6 = FirstDeriv()\n"
		 << "  7 = SecondDeriv()\n"
         << "  8 = TrapRule()\n"
		 << "  9 = SimpRule()\n"
		 << " SELECT: ";
    cin >> menuOption;
	
	switch(menuOption)
	{
    case 1:
    // InterpLinPky()
    cout << "\nTesting InterpLinPky()\n";
	res = InterpLinPky(1.0, 2.0, 3.0, 8.0, 1.5);
	cout << "Value of Pyk = " << res;
	cout << "\n\n";
	break;

    case 2:
    // InterpLinFromTable()
    cout << "\nTesting InterpLinFromTable()\n";
	res = InterpLinFromTable(aX, aY, 3.5, sizeof aX / sizeof aX[0]);
	cout << "Value of Pyk = " << res;
	cout << "\n\n";
	break;

    case 3:
    // InterpLagrange()
    cout << "\nTesting InterpLagrange() in y = 1x for x = 3.5\n";
	cout << "by linear interpolation: ";
	res = InterpLinFromTable(lX, lY, 3.5, sizeof lX / sizeof lX[0]);
	cout << res;
	cout << "\nby Langrange interpolation: ";
	res = InterpLagrange(lX, lY, 3.5, sizeof lX / sizeof lX[0]);
	cout << res;
	cout << "\nExact value: 0.285714286";
	cout << "\n\n";
	break;

	case 4:
 	// Testing LinearLSInterp()
    /*
    yVal = LinearLSInterp(datX, datY, pxk, &error,
		                  sizeof datX / sizeof datX[0]);
	printf("Point pyk by linear least-square interpolation = ");
	printf("%.16f", yVal, "\n");
	printf("\nError sum = ");
	printf("%.16f", error, "\n");
	*/
    yVal = LinearLSInterp(valX, valY, px, &error,
		                  sizeof valX / sizeof valX[0]);
	printf("\nPoint pyk by linear least-square interpolation = ");
	printf("%.16f", yVal);
	printf("\nError sum = ");
	printf("%.16f", error, "\n");
	printf("\n");
	break;

	case 5:
    // Testing NonLinLSInterp()
    yVal = NonLinLSInterp(fofX, fofY, fofx, &error, 
		                  sizeof fofX / sizeof fofX[0]);
	printf("\nPoint pyk by non-linear least-square interpolation = ");
	printf("%.16f", yVal);
	printf("\nError sum = ");
	printf("%.16f", error, "\n");
	printf("\n");
	break;

	case 6:
    // Testing FirstDeriv()
    FirstDeriv(srcY, drvS, sizeof srcY / sizeof srcY[0]);
	printf("\nCalculating first derivatives \n");
	for(j = 0; j < (sizeof drvS / sizeof drvS[0]);j++)
	{
        printf("%.4f", srcY[j]);
		printf("  f' = ");
		printf("%.8f", drvS[j]);
		printf("\n");
    }
	printf("\n");
	break;

	case 7:
    // Testing FirstDeriv()
    SecondDeriv(srcY, drvS, sizeof srcY / sizeof srcY[0]);
	printf("\nCalculating second derivatives \n");
	for(j = 1; j < ((sizeof drvS / sizeof drvS[0]) - 1);j++)
	{
        printf("%.4f", srcY[j]);
		printf("  f' = ");
		printf("%.8f", drvS[j]);
		printf("\n");
    }
	printf("\n");
	break;

	case 8:
    // Testing TrapRule()
    integral = TrapRule(xData, yData, sizeof xData / sizeof xData[0]);
	printf("\nIntegral = ");
	printf("%.16f", integral);

    integral = TrapRule(xDat1, yDat1, sizeof xDat1 / sizeof xDat1[0]);
	printf("\nIntegral = ");
	printf("%.16f", integral);

    integral = TrapRule(xDat2, yDat2, sizeof xDat2 / sizeof xDat2[0]);
	printf("\nIntegral = ");
	printf("%.16f", integral);
	printf("\n\n");

	break;

	case 9:
    // Testing SimpRule()
    integral = SimpRule(xDat1, yDat1, sizeof xDat1 / sizeof xDat1[0]);
	printf("\nIntegral = ");
	printf("%.16f", integral);
	printf("\n\n");

	break;
    

    }
	}

 return 0;
}



