//************************************************************
//                    Linear Systems
//************************************************************
// Reference:   SOFTWARE SOLUTIONS
// Workspace  : Chapter13\Test Un32_11
// Entry point: Test Un32_11
// Other files:
// Development: Visual C++ 6.0 Console Application
// Date:        March 17/2001
//
// Description:
//              Header file for primtive functions used in
//              linear systems programming.
//************************************************************

// Library functions

//**************************************************************
//                       Prototypes
//**************************************************************

//**************************************************************
//                   support functions
//**************************************************************
template <class A>
void FillMatrix(A *matx, int rows, int cols)
{
// Fill a matrix of type any numeric type
// On entry:
//       *mat is caller's matrix 
//       rows is nomber of rows in matrix
//       cols is number of columns in matrix
A entry;

	for(int i = 0;i < rows; i++)
	{
		cout << "Enter row " << i << "\n";

	   for(int j = 0; j < cols; j++)
		{
			cout << "element " << i << " " << j << ": ";
			cin >> entry;
			matx[(i * cols) + j] = entry;
	   }
	}
}

template <class A>
void ShowMatrix(A *matx, int rows, int cols)
{
// Display a matrix of any numeric type
// On entry:
//       *mat is caller's matrix 
//       rows is nomber of rows in matrix
//       cols is number of columns in matrix

for(int i = 0;i < rows; i++)
{
   cout << "\n";
   for(int j = 0; j < cols; j++)
   {
       cout <<  matx[(i * cols) + j];
	   cout << "\t";
   }
}
}

template <class A>
A Locateij(A *matx, int i, int j, int cols)
{
// Locate and return matrix entry at row i, column j
// On entry:
//       *mat is caller's matrix 
//       i = row number
//       j = column number
//       cols = number of matrix columns 
 return (matx[(i * cols) + j]);
}

void FillMatrix2D(int matx[][COLS])
{
// Fill a 2-dimensional matrix of type int
// On entry:
//      *mat is caller's matrix 
//       Constants ROWS and COLS define the array dimensions
int entry;

	for(int i = 0;i < ROWS; i++)
	{
		cout << "Enter row " << i << "\n";

	   for(int j = 0; j < COLS; j++)
		{
			cout << "element " << i << " " << j << ": ";
			cin >> entry;
			matx[i][j] = entry;
	
	   }
	}
}


//**************************************************************
//                     vector arithmetic
//**************************************************************
template <class A>
void RowMulScalar(A *matx, int i, int cols, A scalar)
{
// Multiply a matrix row times a scalar
// On entry:
//       *mat is caller's matrix 
//       i is number of the row
//       cols is number of columns in the matrix
//       scalar is the value to multiply
// On exit:
//       elements in matrix row i are multipliced by scalar

int rowStart = i * cols;

for(int j = 0;j < cols ;j++)
	matx[rowStart + j] *= scalar;
}

template <class A>
void RowPlusScalar(A *matx, int i, int cols, A scalar)
{
// Add a scalar to a matrix row
// On entry:
//       *mat is caller's matrix 
//       i is number of the row
//       cols is number of columns in the matrix
//       scalar is the value to be added
// On exit:
//       Scalar is added to all elements in matrix row i
int rowStart = i * cols;

for(int j = 0;j < cols ;j++)
	matx[rowStart + j] += scalar;
}

template <class A>
void RowMinusScalar(A *matx, int i, int cols, A scalar)
{
// Subtract a scalar from each element in a matrix row
// On entry:
//       *mat is caller's matrix 
//       i is number of the row
//       cols is number of columns in the matrix
//       scalar is the value to be added
// On exit:
//       Scalar is subtracted from all elements in matrix row i
int rowStart = i * cols;

for(int j = 0;j < cols ;j++)
	matx[rowStart + j] -= scalar;
}

template <class A>
void RowDivScalar(A *matx, int i, int cols, A scalar)
{
// Divide all elements in a matrix row by a scalar
// On entry:
//       *mat is caller's matrix 
//       i is number of the row
//       cols is number of columns in the matrix
//       scalar is the value
// On exit:
//       All elements in matrix row i are divided by the
//       scalar
int rowStart = i * cols;

for(int j = 0;j < cols ;j++)
	matx[rowStart + j] /= scalar;
}

template <class A>
void ColMulScalar(A *matx, int j, int rows, int cols, A scalar)
{
// Multiply a matrix column times a scalar
// On entry:
//       *mat is caller's matrix 
//       j is column number
//       rows is the number of rows in the matrix
//       cols is number of columns in the matrix
//       scalar is the value to multiply
// On exit:
//       elements in matrix column j are multiplied by scalar

	for(int i = 0;i < rows ;i++)
	{
		matx[(cols * i) + j] *= scalar;

	}
}

