//************************************************************
//                     Linear Systems
//************************************************************
// Reference:   SOFTWARE SOLUTIONS
// Workspace  : Chapter13\Test Un32_12
// Entry point: Test Un32_12
// Other files: 
//              Un32_12.h
// Development: Visual C++ 6.0 Console Application
// Date:        March 17/2001
//
// Description:
//              Tests for routines in Un32_12 module of
//              math32.lib
//************************************************************

#include <iostream.h>

#include "Un32_12.h"

int main()
{

    // Variables for program
	int menuOption = 1;

	double mat1[] = { 1.0, 1.0, 1.0, 1.0,
		              2.0, 2.0, 2.0, 2.0,
				      3.0, 3.0, 3.0, 3.0,
				      4.0, 4.0, 4.0, 4.0};

	float mat2[] = { 0, 0, 0, 0,
		           1, 1, 1, 1,
				   2, 2, 2, 2,
				   3, 3, 3, 3};

	float mat3[] = { 1, 1, 1, 1,
		             1, 1, 1, 1,
					 2, 2, 2, 2,
					 2, 2, 2, 2};
	float matC[16];

    float matA[] = { 1.0, 2.0, 4.0,
	                 2.0, 6.0, 0.0};

	float matB[] = { 4.0, 1.0, 4.0, 3.0,
	                 0.0,-1.0, 3.0, 1.0,
					 2.0, 7.0, 5.0, 2.0};

	// Product matrix has rows of matA[] * columns of matB[]
	// 2 * 4 = 8
	float matAB[8];

    // Data for linear systems
	double sysS[] = {1.0, 1.0,  1.0, 6.0,
		             2.0, -1.0, 4.0, 12.0,
				    -3.0,  2.0, -1.0, -4.0};
	double sysR[12];

    bool result;

	while(menuOption)
	{ 
    // Display menu
	cout << "FUNCTION TEST MENU\n"
		 << "  0 = END TEST\n"
		 << "  1 = RowTimesScalarLL()    2 = RowPlusScalarLL() \n"
		 << "  3 = RowDivScalarLL()      4 = RowMinusScalarLL() \n"
		 << "  5 = MatTimesScalarLL()    6 = MatPlusScalarLL()\n"
		 << "  7 = MatDivScalarLL()      8 = MatMinusScalarLL()\n"
		 << "  9 = AddMatrices()        10 = MulMatrices()\n"
		 << " 11 = GaussSolve()         12 = GaussSolve() 2\n"
		 << " SELECT: ";
    cin >> menuOption;
	
	switch(menuOption)
	{

    case 1:
    // RowTimesScalarLL()
    ShowMatrix(mat1, 4, 4);
	cout << "\nrow: 0    scalar: 2.0";

	RowTimesScalarLL(mat1, 0, 4, 2.0);
	ShowMatrix(mat1, 4, 4);
	cout << "\n\n";
    break;

    case 2:
    // RowPlusScalarLL()
    ShowMatrix(mat1, 4, 4);
	cout << "\nrow: 0    scalar: 4.0";
	RowPlusScalarLL(mat1, 0, 4, 4.0);
	ShowMatrix(mat1, 4, 4);   // 
	cout << "\n\n";
    break;

    case 3:
    // RowDivScalarLL()
    ShowMatrix(mat1, 4, 4);
	cout << "\nrow: 3    scalar: 2.0";
	RowDivScalarLL(mat1, 3, 4, 2.0);
	ShowMatrix(mat1, 4, 4);   // 
	cout << "\n\n";
    break;

    case 4:
    // RowMinusScalarLL()
    ShowMatrix(mat1, 4, 4);
	cout << "\nrow: 4    scalar: 2.0";
	RowMinusScalarLL(mat1, 3, 4, 2.0);
	ShowMatrix(mat1, 4, 4);   // 
	cout << "\n\n";
    break;

     case 5:
    // MatTimesScalarLL()
    ShowMatrix(mat2, 4, 4);
	cout << "\nscalar: 2(float)";
	MatTimesScalarLL(mat2, 4, 4, 2.0f);
	ShowMatrix(mat2, 4, 4);
	cout << "\n\n";
    break;


     case 6:
    // MatPlusScalarLL()
    ShowMatrix(mat2, 4, 4);
	cout << "\nscalar: 2(float)";
	MatPlusScalarLL(mat2, 4, 4, 2.0f);
	ShowMatrix(mat2, 4, 4);
	cout << "\n\n";
    break;

     case 7:
    // MatDivScalarLL()
    ShowMatrix(mat2, 4, 4);
	cout << "\nscalar: 2(float)";
	MatDivScalarLL(mat2, 4, 4, 2.0f);
	ShowMatrix(mat2, 4, 4);
	cout << "\n\n";
    break;

     case 8:
    // MatMinusScalarLL()
    ShowMatrix(mat2, 4, 4);
	cout << "\nscalar: 2(float)";
	MatMinusScalarLL(mat2, 4, 4, 2.0f);
	ShowMatrix(mat2, 4, 4);
	cout << "\n\n";
    break;

    case 9:
    // AddMatrices()
    ShowMatrix(mat2, 4, 4);
	cout << "\n";
	ShowMatrix(mat3, 4, 4);
	cout << "\n";
	AddMatrices(mat2, mat3, matC, 4, 4);
	ShowMatrix(matC, 4, 4);
	cout << "\n\n";
    break;

    case 10:
    // MulMatrices()
    ShowMatrix(matA, 2, 3);
	cout << "\n";
	ShowMatrix(matB, 3, 4);
	cout << "\n";
	result = MulMatrices(matA, matB, matAB, 2, 3, 3, 4);
	if(result)
		ShowMatrix(matAB, 2, 4);
	else
		cout << "Invalid matrix size";
	cout << "\n\n";
    break;

    case 11:
    // GaussSolve()
    ShowMatrix(sysS, 3, 4);
	cout << "\n";
	GaussSolve(sysS, sysR, 3, 4);
	ShowMatrix(sysR, 3, 4);
	cout << "\n\n";
    break;

    case 12:
    // GaussSolve() using a single matrix
    ShowMatrix(sysS, 3, 4);
	cout << "\n";
	GaussSolve(sysS, sysS, 3, 4);
	ShowMatrix(sysS, 3, 4);
	cout << "\n\n";
    break;

    }
	}

 return 0;
}



