//************************************************************
//         Test module for comparing C/C++ and BCD20
//                      arithmetic
//************************************************************
// Reference:   SOFTWARE SOLUTIONS Chapter 4
// Workspace  : Chapter4\BCD20 Comparisons
//
// Entry point: BCD20 Comparison.cpp
// Other files: bcd20math.cpp
//              bcd20math.h
// Development: Visual C++ 6.0 Console Application
// Date:        December 23/2000
//
// Description:
//          Comparing C/C++ and BCD20 arithmetic
//***********************************************************
#include "stdafx.h"
#include <iostream.h>
#include <iomanip.h>
#include "bcd20math.h"
#include <stdio.h>

// Global data
// Source numbers for tests 
char asc1[] = "1.22334455667788771122334455667711";
char asc2[] = "1.11111111111111111111111111111111";


double largeDouble = 1.2233445566778877665544;

// BCD data
char num1[20];
char num2[20];
char bcdResult[20];
// ASCII data
char ascResult[52];


int main()
{
  
    cout << "\ndouble defined as: 1.2233445566778877665544";
	cout << setprecision(50) << setw(50);
	cout << "\ndisplayed        : " << largeDouble;
	cout << "\n\n";

	// BCD20 addition
    AsciiToBcd20(asc1, num1);
    AsciiToBcd20(asc2, num2);

	SignAddBcd20(num1, num2, bcdResult);

	Bcd20ToAscStr(bcdResult, ascResult);

    cout << "\nFirst addend  : " << asc1;
    cout << "\nSecond addend : " << asc2;
	cout << "\nSum           :" << ascResult << "\n\n";


  return 0;
}

