//************************************************************
//        Testing calculator primitives
//************************************************************
// Reference:   SOFTWARE SOLUTIONS
// Workspace  : Chapter9\Test Mu32_7
// Entry point: Test Mu32_7
// Other files: Un32_7.asm
//              Un32_7.h
// Development: Visual C++ 6.0 Console Application
// Date:        January 25/2001
//
// Description:
//              Tests for procedures in Un32_7 module of
//              math32.lib
//************************************************************
#include "stdafx.h"
#include "Un32_7.h"
#include <iostream.h>
#include <conio.h>
#include <stdio.h>
#include <iomanip.h>

// Prototype
void WaitEOL();


int main()
{
    // Variables for program
	int menuOption = 1;

	// Variables for tests
    double arg1, arg2, arg3;
	double a, bi, c, di;
	double polarA, polarR;
	double cartX, cartY; 
	double real, imaginary, absolute;
	double root1, root2;
	int rType;
	int argi1, argi2;
	int resulti;
	double result;
	long facto;
	double angle;
	double sideb;
	double sidea;
    
	// Set width and precesion for output functions
    cout.precision(20);       // Max     
    cout.width(20);           // Max

  while(menuOption)
  { 
    // Display menu
	cout << "FUNCTION TEST MENU\n"
		 << "  0 = END TEST\n"
	     << "  1 = Factorial()\n"
		 << "  2 = SolveForA()\n"
	     << "  3 = Max() and Min()\n"
	     << "  4 = Modulus()\n"
		 << "  5 = Pytahgoras()\n"
		 << "  6 = FracPart and IntPart()\n"
         << "  7 = QuadFormReal()\n"
         << "  8 = QuadFormula()\n"
		 << "  9 = AddComplex()\n"
		 << " 10 = SubComplex()\n"
		 << " 11 = MulComplex()\n"
		 << " 12 = DivComplex()\n"
		 << " 13 = AbsComplex()\n"
		 << " 14 = PolarToCart()\n"
		 << " 15 = CartToPolar()\n"
		 << " SELECT: ";
    cin >> menuOption;
	
	switch(menuOption)
	{
    case 1:
    // Factorial()
    cout << "\nTesting Factorial()";
	cout << "\nEnter x: ";
	cin >> argi1;
    facto = Factorial(argi1); 
	cout << "x! = " << facto << "\n";
	break;

    case 2:
	// SolveForA()
    cout << "\nTesting SolveForA()\n";
    cout << "Enter angle in degrees: ";
	cin >> angle;
	cout << "Enter adjacent side: ";
	cin >> sidea;
    sideb = SolveForA(angle, sidea); 
	cout << "side b = " << sideb << "\n\n";
	break;

	case 3:
    // Max() and Min()
    cout << "\nTesting Max() and Min()\n";
    cout << "Enter x: ";
	cin >> arg1;
	cout << "Enter y: ";
	cin >> arg2;
    result = Max(arg1, arg2);
	cout << "Maximum is: " << result << "\n"; 
    result = Min(arg1, arg2);
	cout << "Minimum is: " << result << "\n\n";
	break;

	case 4:
    // Modulus()
    cout << "\nTesting Modulus(x/y) \n";
    cout << "Enter x: ";
	cin >> argi1;
	cout << "Enter y: ";
	cin >> argi2;
    resulti = Modulus(argi1, argi2);
	cout << "Modulus x / y : " << resulti << "\n";
	break;

    case 5:
	// Pythagoras()
    cout << "\nTesting Pythagoras()\n";
    cout << "Enter a: ";
	cin >> arg1;
	cout << "Enter b: ";
	cin >> arg2;
    result = Pythagoras(arg1, arg2); 
	cout << "SQRT(a^2+b^2)= " << result << "\n\n";
	break;
	
    case 6: 
	// FracPart() and IntPart()
    cout << "\nTesting FracPart() and IntPart()\n";
    cout << "Enter x: ";
	cin >> arg1;
    result = FracPart(arg1);
	cout << "Fractional part: " << result << "\n";	
    resulti = IntPart(arg1);
	cout << "Integer part: " << resulti << "\n\n";
    break;

	case 7:
	// QuadFormReal()
    cout << "\nTesting QuadFormReal()\n";
    cout << "Enter coefficient a: ";
	cin >> arg1;
    cout << "Enter coefficient b: ";
	cin >> arg2;
    cout << "Enter coefficient c: ";
	cin >> arg3;
    QuadFormReal(arg1, arg2, arg3, &root1, &root2);
	cout << "First root:  " << root1 << "\n";	
	cout << "Second root: " << root2 << "\n\n";
	break;

	case 8:
	// QuadFormula()
    cout << "\nTesting QuadFormula()\n";
    cout << "Enter coefficient a: ";
	cin >> arg1;
    cout << "Enter coefficient b: ";
	cin >> arg2;
    cout << "Enter coefficient c: ";
	cin >> arg3;
    rType = QuadFormula(arg1, arg2, arg3, &root1, &root2);
	if(rType)
		cout << "Equation has imaginary roots\n";
	else
		cout << "Equation has real roots\n";
	cout << "First root:  " << root1 << "\n";	
	cout << "Second root: " << root2 << "\n\n";
	break;

	case 9:
	// AddComplex()
    cout << "\nTesting AddComplex()\n";
	cout << "Operation: (a+bi)+(c+di)=(a+c)+i(b+d)\n";
    cout << "Enter a: ";
	cin >> a;
    cout << "Enter bi: ";
	cin >> bi;
    cout << "Enter c: ";
	cin >> c;
	cout << "Enter di: ";
	cin >> di;
    AddComplex(a, bi, c, di, &real, &imaginary);
	cout << "Real part:  " << real << "\n";	
	cout << "Imaginary part: " << imaginary << "\n\n";
	break;

	case 10:
	// SubComplex()
    cout << "\nTesting SubComplex()\n";
	cout << "Operation: (a+bi)-(c+di)=(a-c)+i(b-d)\n";
    cout << "Enter a: ";
	cin >> a;
    cout << "Enter bi: ";
	cin >> bi;
    cout << "Enter c: ";
	cin >> c;
	cout << "Enter di: ";
	cin >> di;
    SubComplex(a, bi, c, di, &real, &imaginary);
	cout << "Real part:  " << real << "\n";	
	cout << "Imaginary part: " << imaginary << "\n\n";
	break;

	case 11:
	// MulComplex()
    cout << "\nTesting MulComplex()\n";
	cout << "Operation: (a+bi)(c+di)=(ac-bd)+i(ad+bc)\n";
    cout << "Enter a: ";
	cin >> a;
    cout << "Enter bi: ";
	cin >> bi;
    cout << "Enter c: ";
	cin >> c;
	cout << "Enter di: ";
	cin >> di;
    MulComplex(a, bi, c, di, &real, &imaginary);
	cout << "Real part:  " << real << "\n";	
	cout << "Imaginary part: " << imaginary << "\n\n";
	break;

	case 12:
	// DivComplex()
    cout << "\nTesting DivComplex()\n";
	cout << "Operation: (a+bi)/(c+di)=(ac+bd)+i(bc-ad)/"
		 << "c^2 + d^2\n";
    cout << "Enter a: ";
	cin >> a;
    cout << "Enter bi: ";
	cin >> bi;
    cout << "Enter c: ";
	cin >> c;
	cout << "Enter di: ";
	cin >> di;
    DivComplex(a, bi, c, di, &real, &imaginary);
	cout << "Real part:  " << real << "\n";	
	cout << "Imaginary part: " << imaginary << "\n\n";
	break;

	case 13:
	// AbsComplex()
    cout << "\nTesting AbsComplex()\n";
	cout << "Operation: |a+bi| = SQR(a^2 + b^2)\n";
    cout << "Enter a: ";
	cin >> a;
    cout << "Enter bi: ";
	cin >> bi;
    absolute = AbsComplex(a, bi);
	cout << "Absolute value: " << absolute << "\n\n";	
	break;

	case 14:
	// PolarToCart()
    cout << "\nTesting PolarToCart()\n";
    cout << "Enter polar angle (degrees): ";
	cin >> polarA;
    cout << "Enter polar radius: ";
	cin >> polarR;
    PolarToCart(polarA, polarR, &cartX, &cartY);
	cout << "Cartesian x: " << cartX << "\n";
	cout << "Cartesian y: " << cartY << "\n\n";	
	break;

	case 15:
	// CartToPolar()
    cout << "\nTesting CartToPolar()\n";
    cout << "Enter cartesian x: ";
	cin >> cartX;
    cout << "Enter cartesian y: ";
	cin >> cartY;
    CartToPolar(cartX, cartY, &polarA, &polarR);
	cout << "Polar angle: " << polarA << "\n";
	cout << "Polar radius: " << polarR << "\n\n";	
	break;

    }
  }
 return 0;
}

