;*****************************************************************
;*****************************************************************
;                           TEST_EQU.ASM
;*****************************************************************
;*****************************************************************
; Description:
;             Test and demonstration for the CALCULATE_Y procedure
;             in the UNIT_9 module of the MATHUNIT library
;
;*****************************************************************
EXTRN   DOS_STRING_OUT: FAR
EXTRN   KBR_WAIT:       FAR
EXTRN   INPUT_NUMBER:   FAR
EXTRN   OUTPUT_NUMBER:  FAR
;
EXTRN   CALCULATE_Y:    FAR
;
INCLUDELIB MATHUNIT
INCLUDELIB SOLUTION
;****************************************************************
;                          stack segment
;****************************************************************
STACK  SEGMENT stack

               DB      0400H DUP ('?'); Default stack is 1K
STACK_TOP      EQU     THIS BYTE
;
STACK  ENDS
;
;****************************************************************
;                          data segment
;****************************************************************
DATA    SEGMENT
;
S_MES   DB      'Equation solver according to the following'
        DB      ' rules and keywords: ',0AH,0DH
        DB      'Trigonometry: SIN COS TAN ASIN ACOS ATAN'
        DB      ' (angles in degrees)',0AH,0DH
        DB      'Arithmetic operators: ^ * / + -',0AH,0DH
        DB      'Parenthesis are allowed. Spaces are optional'
        DB      0AH,0DH
        DB      'Independent variable = X or x',0AH,0DH
        DB      'Example equation: y=x^2+3.5*(x/(COS45-x))'
        DB      0AH,0DH
        DB      '$'
;
X_MES   DB      0AH,0DH
        DB      'Press <x> for new value of x',0AH,0DH
        DB      'Press <e> for new equation',0AH,0DH
        DB      'Press <ESC> to exit',0AH,0DH
        DB      '$'
;
Y_MES   DB      'y = $'
;
MESS1           DB      0AH,0DH,'Enter equation: $'
MESS2           DB      0AH,0DH,'Enter x: $'
;
DOS_BUF         DB      40      ; 40 characters maximum
                DB      0       ; Input counter
EQU_STRING      DB      40 DUP (0H)
;
DATA    ENDS
;
;****************************************************************
;                          code segment
;****************************************************************
;
CODE    SEGMENT
        ASSUME  CS:CODE

START:
;*******************|
;  initialization   |
;*******************|
; Establish data and extra segment addressability
        MOV     AX,DATA         ; Address of DATA to AX
        MOV     DS,AX           ; and to DS
        ASSUME  DS:DATA         ; Assume from here on
;***********************************|
;           program code            |
;***********************************|
        LEA     DX,S_MES        ; Pointer to text message
        CALL    DOS_STRING_OUT  ; Library procedure
;
NEW_EQUATION:
        FINIT
        LEA     DX,MESS1        ; Pointer to text message
        CALL    DOS_STRING_OUT  ; Library procedure
        LEA     DX,DOS_BUF      ; Pointer to input buffer
        MOV     AH,10           ; DOS service number
        INT     21H
; At this point the equation is in EQU_STRING
; Replace 0DH in buffer with 0H
        MOV     DI,DX           ; To index register
        INC     DI              ; DI --> start of data area
        MOV     AL,[DI]         ; Number of characters input
        INC     DI              ; Point to start of bufffer
        MOV     AH,0            ; Clear high byte
        ADD     DI,AX           ; Add input length
        MOV     BYTE PTR [DI],0 ; Replace 0DH with 0H
; Get value of x
NEW_X_VALUE:
        LEA     DX,MESS2        ; Pointer to text message
        CALL    DOS_STRING_OUT  ; Library procedure
        CALL    INPUT_NUMBER    ; Input super procedure
; x is now in ST(0)
        LEA     SI,EQU_STRING   ; Pointer to text
        CALL    CALCULATE_Y     ; Procedure in UNIT_9 module
        LEA     DX,Y_MES        ; Pointer to text message
        CALL    DOS_STRING_OUT  ; Library procedure
        CALL    OUTPUT_NUMBER
; Exit message
        LEA     DX,X_MES        ; Pointer to text message
        CALL    DOS_STRING_OUT  ; Library procedure
        CALL    KBR_WAIT        ; Library procedure
; AL holds keyboard character. AX holds scan code
        CMP     AX,011BH        ; <Esc> key?
        JNE     NOT_ESC_KEY     ; Go if not escape
        JMP     DOS_EXIT        ; End of program
NOT_ESC_KEY:
        CMP     AL,'x'          ; Test for x
        JE      NEW_X_VALUE     ; Go if x
        CMP     AL,'X'          ; Test capital X
        JE      NEW_X_VALUE     ; Go if X
        JMP     NEW_EQUATION
;
;************************|
;     DOS exit           |
;************************|
DOS_EXIT:
        MOV     AH,4CH          ; DOS service request code
        MOV     AL,0            ; No error code returned
        INT     21H             ; TO DOS

CODE    ENDS
        END     START

  AL,0            ; No error code returned
        INT     21H             ; TO DOS

CODE    ENDS
        