;*****************************************************************
;*****************************************************************
;                           TEST_ID.ASM
;*****************************************************************
;*****************************************************************
; Description:
;            Test and demonstration program for the ID_FPU
;            procedure in the UNIT_2 module of the MATHUNIT
;            library
;
;*****************************************************************
EXTRN   ID_FPU: FAR
;
INCLUDELIB MATHUNIT
;****************************************************************
;                          stack segment
;****************************************************************
STACK  SEGMENT stack

               DB      0400H DUP ('?'); Default stack is 1K
STACK_TOP      EQU     THIS BYTE
;
STACK  ENDS
;
;****************************************************************
;                          data segment
;****************************************************************
DATA    SEGMENT
MESS_NOFPU      DB      0AH,0DH
                DB      'No coprocessor or math unit present$'
MESS_8087       DB      0AH,0DH
                DB      'Coprocessor is 8087$'
MESS_287        DB      0AH,0DH
                DB      'Coprocessor is 80287$'
MESS_387        DB      0AH,0DH
                DB      'Coprocessor is 80387$'
MESS_486        DB      0AH,0DH
                DB      'Coprocessor is 486 math unit or 486/'
                DB      '80387 system$'
MESS_PENT       DB      0AH,0DH
                DB      'Coprocessor is math unit in Pentium$'
;
DATA    ENDS
;
;
;****************************************************************
;                          code segment
;****************************************************************
;
CODE    SEGMENT
        ASSUME  CS:CODE
;
START:
;*******************|
;  initialization   |
;*******************|
; Establish data and extra segment addressability
        MOV     AX,DATA         ; Address of DATA to AX
        MOV     DS,AX           ; and to DS
        ASSUME  DS:DATA         ; Assume from here on
; Initialize stack. Note that this instruction is necessary for
; compatibility with non-Microsoft assemblers
        LEA     SP,SS:STACK_TOP ; Stack pointer to top of stack
;***********************************|
;       determine CPU installed     |
;***********************************|
        CALL    ID_FPU          ; Library procedure
;
        LEA     DX,MESS_NOFPU   ; Pointer to text message
        CMP     AL,0            ; Test AL for code
        JNE     MESS_01         ; Go if not 0
        JMP     DISPLAY_MESS    ; Go to display routine
MESS_01:
        LEA     DX,MESS_8087    ; Pointer to text message
        CMP     AL,01           ; Test AL for code
        JNE     MESS_02         ; Go if not expected ID code
        JMP     DISPLAY_MESS    ; Go to display routine
MESS_02:
        LEA     DX,MESS_287     ; Pointer to text message
        CMP     AL,02           ; Test AL for code
        JNE     MESS_03         ; Go if not expected ID code
        JMP     DISPLAY_MESS    ; Go to display routine
MESS_03:
        LEA     DX,MESS_387     ; Pointer to text message
        CMP     AL,03           ; Test AL for code
        JNE     MESS_04         ; Go if not expected ID code
        JMP     DISPLAY_MESS    ; Go to display routine
MESS_04:
        LEA     DX,MESS_486     ; Pointer to text message
        CMP     AL,04           ; Test AL for code
        JNE     MESS_05         ; Go if not expected ID code
        JMP     DISPLAY_MESS    ; Go to display routine
MESS_05:
        LEA     DX,MESS_PENT    ; Pointer to text message
; Use MS DOS service number 9 to display text message
DISPLAY_MESS:
        MOV     AH,9            ; MS DOS function number
        INT     21H
;
;*******************|
;   exit to DOS     |
;*******************|
DOS_EXIT:
        MOV     AH,4CH          ; DOS service request code
        MOV     AL,0            ; No error code returned
        INT     21H             ; TO DOS
;
CODE    ENDS
        END     START           ; Reference to label at which
                                ; execution begins

    ENDS
        END     STA